words = []
things = {}
now = []
array = []
stack = []

#anyone can modify this Forth for other chalenges in the competition
#I release all rights to the code

def entry(thing):
    for i in range(len(array)):
        del array[0]
    for i in range(len(thing)):
        array.append(thing[i])
    forth(": countless dup 1 + length for do: get item < if do: 1 + ; ; ; : put goal while do: dup get item == ; do: 1 + ; dup get swap item set store item ; 0 length 1 - for do: (i) dup dup dup (i i i i) get (i i i item) store item (i i i) countless (i i g) dup (i i g g) store goal (i i g) != if do: (i) put (i) while do: (i) dup (i i) goal (i i g) != ; do: (i) put (i) dup (i i) countless (i g') store goal (i) ; (i) item (i item) set ; ;")
    return array

def next():
    next = words[0]
    del words[0]
    return next

def nextAndCompile():
    thing = next()
    while thing in now:
        things[thing]()
        thing = next()
    return thing

def pop():
    pop = stack[-1]
    del stack[-1]
    return pop

def push(thing):
    stack.append(thing)

def word(func, name = None, do_now = False):
    if name == None:
        name = str(func).split()[1]
    things[name] = func
    if do_now:
        now.append(name)
    return func

def eq():
    push(pop() == pop())
word(eq, "==")

def notEq():
    push(pop() != pop())
word(notEq, "!=")

def plus():
    push(pop() + pop())
word(plus, "+")

def minus():
    push(-pop() + pop())
word(minus, "-")

def lessThan():
    push(pop() > pop())
word(lessThan, "<")

def func():
    thing = nextAndCompile()
    x = []
    word = nextAndCompile()
    while word != ";":
        x.append(word)
        word = nextAndCompile()
    def func():
        words.reverse()
        words.append(x)
        words.reverse()
    things[thing] = func
word(func, ":")

def do():
    x = []
    thing = nextAndCompile()
    while thing != ";":
        x.append(thing)
        thing = nextAndCompile()
    words.reverse()
    words.append(x)
    words.reverse()
word(do, "do:", True)

def end():
    return
word(end, ";")
@word

def length():
    push(len(array))
@word

def get():
    push(array[pop()])
@word

def set():
    print("Modified")
    array[pop()] = pop()
@word

def dup():
    thing = pop()
    push(thing)
    push(thing)

def comments(thing):
    brackets = False
    done = ""
    for i in range(len(thing)):
        if thing[i] == "(":
            brackets = True
        if thing[i] == ")":
            brackets = False
        elif brackets == False:
            done = done + thing[i]
    return done
@word

def swap():
    a = pop()
    b = pop()
    push(a)
    push(b)
@word

def store():
    name = nextAndCompile()
    thing = pop()
    def get_value():
        push(thing)
    things[name] = get_value

def forLoop():
    body = nextAndCompile()
    stop = pop()
    start = pop()
    words.reverse()
    for i in range(start, stop):
        words.append(body)
        words.append(start + stop - i - 1)
    words.reverse()
word(forLoop, "for")

def whileLoop():
    condition = nextAndCompile()
    body = nextAndCompile()
    thing = [condition, "if", [body, "while", condition, body]]
    words.reverse()
    words.append(thing)
    words.reverse()
word(whileLoop, "while")
@word

def debug():
    print(pop())
@word

def debugAt():
    print(next())

def ifStatement():
    body = nextAndCompile()
    if pop():
        words.reverse()
        words.append(body)
        words.reverse()
word(ifStatement, "if")

def forth(forth):
    if compile != True:
        forth = comments(forth)
        forth = forth.split()
        for thing in range(len(forth)):
            thing = forth[thing]
            words.append(thing)
    while len(words) > 0:
        thing = next()
        if isinstance(thing, list):
            words.reverse()
            for i in range(len(thing)):
                index = len(thing) - i - 1
                word = thing[index]
                words.append(word)
            words.reverse()
        else:
            try:
                stack.append(int(thing))
            except:
                thing = things[thing]
                thing()
